SLASH_LH1 = "/LootHistory";
SLASH_LH2 = "/LH";
LootHistoryVersion = "LootHistory v0.4";
iRarity = {};
iRarity[0]=false; --poor (grey)
iRarity[1]=false; --common (white)
iRarity[2]=true; --uncommon (green)
iRarity[3]=true; --rare (blue)
iRarity[4]=true; --epic (purple)
iRarity[5]=true; --legendary (orange)
iRarity[6]=false; --artifact
iRarity[7]=false; --heirloom
reportTo = {};
reportTo["ChatFrame1"]=true;
reportTo["Say"]=false;
reportTo["Yell"]=false;
reportTo["Party"]=false;
reportTo["Raid"]=false;
reportTo["Guild"]=false;

--begin localization
if (GetLocale() == "deDE") then
	strfindLoot="Beute: ";
	substruserName="Ihr";
elseif (GetLocale() == "enUS") then
	strfindLoot="loot: ";
	substruserName="You";
else
	--[[ 
	feel free to create the following localizations (you can contact me via curse.com):
	"frFR": French
	"koKR": Korean
	"zhCN": Chinese (simplified)
	"zhTW": Chinese (traditional)
	"ruRU": Russian (UI AddOn)
	"esES": Spanish (Spain)
	"esMX": Spanish (Mexico)
	]]--
	strfindLoot="loot: ";
	substruserName="You";
	ChatFrame1:AddMessage("|cffff0000"..LootHistoryVersion..": Your WoW-Version isn't compatible. This is caused by localization issues.|r");
end
--end localization

function AddLootHistory(arg1)	
	local s = string.find(arg1, "%|");
	local e = string.find(arg1, "%|h%|r");	
	local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(string.sub(arg1, s, e));
	local userName = string.sub(arg1, 0, (string.find(arg1, " ")-1));	
	if userName==substruserName then
		userName = UnitName("player");
	end
	if (not(itemType == "Money")) and ((iRarity[0] and itemRarity == 0) or
									   (iRarity[1] and itemRarity == 1) or
									   (iRarity[2] and itemRarity == 2) or
									   (iRarity[3] and itemRarity == 3) or
									   (iRarity[4] and itemRarity == 4) or
									   (iRarity[5] and itemRarity == 5) or
									   (iRarity[6] and itemRarity == 6) or
									   (iRarity[7] and itemRarity == 7)
									) then
		if LootHistory[userName] == nil then
			LootHistory[userName]={};
		end
		tinsert(LootHistory[userName], itemLink);		
	end
end

function AddLootHistory2(userName, itemLink)
	ChatFrame1:AddMessage(LootHistoryVersion.. " - AddLootHistory");	
	if userName==substruserName then		
		userName = UnitName("player");		
	end
	if LootHistory[userName] == nil then
		LootHistory[userName]={};
	end
	tinsert(LootHistory[userName], itemLink);
	ChatFrame1:AddMessage(userName ..": "..itemLink.." successfully added");
end

function RemoveLootHistory(userName, i)	
	ChatFrame1:AddMessage(LootHistoryVersion.. " - RemoveLootHistory");	
	if not(LootHistory[userName] == nil) then		
		if (i<=#LootHistory[userName]) and (i>=0) then
			tremove(LootHistory[userName], i);
			ChatFrame1:AddMessage(userName ..": "..itemLink.." successfully removed");
		end
	end
end

function RemoveLootHistory2(userName, itemLink)
	ChatFrame1:AddMessage(LootHistoryVersion.. " - RemoveLootHistory");	
	if not(LootHistory[userName] == nil) then		
		local x = -1;
		for i, iLink in ipairs(LootHistory[userName]) do
			if iLink == itemLink then
				x=i;
			end
		end
		if (x<=#LootHistory[userName]) and (x>=0) then			
			tremove(LootHistory[userName], x);
			ChatFrame1:AddMessage(userName ..": "..itemLink.." successfully removed");
		end
	end
end

function ShowLootHistory()
	if reportTo["ChatFrame1"] then
		ChatFrame1:AddMessage("~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
		ChatFrame1:AddMessage(LootHistoryVersion.. " - ShowLootHistory");
	end
	if reportTo["Say"] then
	end
	if reportTo["Yell"] then
	end
	if reportTo["Party"] then
	end
	if reportTo["Raid"] then
	end
	if reportTo["Guild"] then
	end	
	for userName, i in pairs(LootHistory) do
		for i, itemLink in ipairs(LootHistory[userName]) do
			if reportTo["ChatFrame1"] then
				ChatFrame1:AddMessage(userName ..": "..itemLink);
			end
			if reportTo["Say"] then
			end
			if reportTo["Yell"] then
			end
			if reportTo["Party"] then
			end
			if reportTo["Raid"] then
			end
			if reportTo["Guild"] then
			end			
		end
	end
	if reportTo["ChatFrame1"] then
		ChatFrame1:AddMessage("~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
	end
	if reportTo["Say"] then
	end
	if reportTo["Yell"] then
	end
	if reportTo["Party"] then
	end
	if reportTo["Raid"] then
	end
	if reportTo["Guild"] then
	end	
end

function ShowPlayerLootHistory(userName)
	if reportTo["ChatFrame1"] then
		ChatFrame1:AddMessage("~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
		ChatFrame1:AddMessage(LootHistoryVersion.. " - ShowPlayerLootHistory");
		ChatFrame1:AddMessage("LootHistory of "..userName..":");
	end
	if reportTo["Say"] then
	end
	if reportTo["Yell"] then
	end
	if reportTo["Party"] then
	end
	if reportTo["Raid"] then
	end
	if reportTo["Guild"] then
	end	
	if not(LootHistory[userName] == nil) then
		for i, itemLink in ipairs(LootHistory[userName]) do			
			if reportTo["ChatFrame1"] then
				ChatFrame1:AddMessage(userName ..": "..itemLink);
			end
			if reportTo["Say"] then
			end
			if reportTo["Yell"] then
			end
			if reportTo["Party"] then
			end
			if reportTo["Raid"] then
			end
			if reportTo["Guild"] then
			end
		end
	end
	if reportTo["ChatFrame1"] then
		ChatFrame1:AddMessage("~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
	end
	if reportTo["Say"] then
	end
	if reportTo["Yell"] then
	end
	if reportTo["Party"] then
	end
	if reportTo["Raid"] then
	end
	if reportTo["Guild"] then
	end
end

function ClearLootHistory()
	ChatFrame1:AddMessage(LootHistoryVersion.. " - ClearLootHistory");	
	wipe(LootHistory);
end

function LootHistoryOnEvent(self, event, ...)	
	if event == "ADDON_LOADED" and arg1 == "LootHistory" then		
		if LootHistory == nil then
			LootHistory = {};
		end
	end
	if event == "CHAT_MSG_LOOT" then
		if UnitInRaid("Player") or UnitInParty("Player") then
			if strfind(arg1, strfindLoot) then
				AddLootHistory(arg1);
			end
		end
	end
end	

LootHistoryFrame = CreateFrame("FRAME", "LootHistoryFrame", UIParent);
LootHistoryFrame:RegisterEvent("ADDON_LOADED");
LootHistoryFrame:RegisterEvent("CHAT_MSG_LOOT");
LootHistoryFrame:SetScript("OnEvent", LootHistoryOnEvent);
LootHistoryFrame:Hide();

SlashCmdList["LH"] = function(param)
	local param1
	local s, e = string.find(param, " ");
	if s == nil then
		param1=" ";
		if (param == "toggle") or (string.len(param) == 0) then
		ChatFrame1:AddMessage("~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
		ChatFrame1:AddMessage(LootHistoryVersion);
		ChatFrame1:AddMessage("/lh [command] or /loohistory [command]");
		ChatFrame1:AddMessage("available commands:");
		ChatFrame1:AddMessage("- show - shows you the current loot history");
		ChatFrame1:AddMessage("- show [name] - shows you the current loot history of [name]");
		ChatFrame1:AddMessage("- clear - wipes the loot history");
		ChatFrame1:AddMessage("~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
		elseif param == "clear" then
			ClearLootHistory();
		elseif param == "show" then
			ShowLootHistory();
		end		
	else
		param1 = string.sub(param, 0, e-1);
	end	
	if param1 == "add" then
		local args = {};
		local i = 0;
		local params = string.sub(param, e+1);
		s, e = string.find(params, " ");
		while (not(e == nil)) and (not(i >= 2)) do
			args[i]=string.sub(params, 0, e-1);			
			params = string.sub(params, e+1);
			s, e = string.find(params, " ");
			i=i+1;
		end
		if (not(i==0)) and (not(i >= 2)) and (not (string.sub(params, 0) == "")) then
			args[i]=string.sub(params, 0);
		end		
		if (#args == 1) and (not(i >= 2)) then
			AddLootHistory2(args[0], args[1]);
		end
	elseif param1 == "remove" then
		local args = {};
		local i = 0;
		local params = string.sub(param, e+1);
		s, e = string.find(params, " ");
		while (not(e == nil)) and (not(i >= 2)) do
			args[i]=string.sub(params, 0, e-1);			
			params = string.sub(params, e+1);
			s, e = string.find(params, " ");
			i=i+1;
		end
		if (not(i==0)) and (not(i >= 2)) and (not (string.sub(params, 0) == "")) then
			args[i]=string.sub(params, 0);
		end		
		if (#args == 1) and (not(i >= 2)) then
			RemoveLootHistory2(args[0], args[1]);
		end
	elseif param1 == "show" then
		local args = {};		
		local params = string.sub(param, e+1);
		s, e = string.find(params, " ");		
		if (e == nil) and (not (string.sub(params, 0) == "")) then			
			args[0]=string.sub(params, 0);
		end		
		if (#args == 0) and not(args[0] == nil) and e == nil then
			--ChatFrame1:AddMessage("GetPlayerLootHistory("..tostring(args[0])..")");
			ShowPlayerLootHistory(args[0]);
		end
	end	
end